#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <limits.h>

#define PROG "fileuidgid"
#define FATAL PROG ": fatal: "
#define WARNING PROG ": warning: "

int main(int argc, char** argv) {
  struct stat statbuf;
  char buf[sizeof (unsigned long)*CHAR_BIT/3+1];

  if (argc<3)
    strerr_die4x(111, PROG, ": usage: ", PROG, " file command [arg ...]");

  if (stat(argv[1], &statbuf)!=0)
    strerr_die4sys(111, FATAL, "unable to stat ", argv[1], ": ");

  if (statbuf.st_uid!=(unsigned long)statbuf.st_uid)
    strerr_die2x(100, FATAL, "uid overflows unsigned long");
  if (statbuf.st_gid!=(unsigned long)statbuf.st_gid)
    strerr_die2x(100, FATAL, "gid overflows unsigned long");

  buf[fmt_ulong(buf, statbuf.st_uid)]='\0';
  if (pathexec_env("UID", buf)==0)
    strerr_die2sys(111, FATAL, "unable to set $UID: ");
  buf[fmt_ulong(buf, statbuf.st_gid)]='\0';
  if (pathexec_env("GID", buf)==0)
    strerr_die2sys(111, FATAL, "unable to set $GID: ");

  pathexec(argv+2);
  strerr_die4sys(111, FATAL, "unable to execute ", argv[2], ": ");
  return 111;
}
